        program stnavg
c
	character*80 filename
	real*4 lstart(100),lstop(100),f(100)
	integer lstn(100,2),n(100)
	real*4 u(100),v(100),az(100),wt(100)
	real*4 xstart(100),xstop(100),ystart(100),ystop(100)
	real*8 x1,y1,x2,y2,d12,az12,az21
c
        open(unit=10,file='pairs.dat',status='OLD',READONLY)
	do i=1,100
	read(10,*,end=90)lstn(i,1),lstn(i,2),lstart(i),ystart(i),
     :  xstart(i),lstop(i),ystop(i),xstop(i)
	end do
c
90	npair=i-1
c
	do j=1,npair
	x1=xstart(j)
	x2=xstop(j)
	y1=ystart(j)
	y2=ystop(j)
	call geodinv (y1,x1,y2,x2,d12,az12,az21)
	az(j)=az12
	wt(j)=d12
	ymean=(y1+y2)/2.
	f(j)=2. * 7.29e-5 * sind(ymean)
	end do
c
	filename='w5:[indian.winds.i1]YNG_TRUE_CMP.LAB'
	open(unit=13,file=filename,status='old',readonly,
     :     form='formatted')
c
	do i=1,100000
	read(13,*,end=955)yr,atime,dum,dum,dir,spd
c
c	find station pair 
c
	utst=spd*cosd(90-dir)
	vtst=spd*sind(90-dir)
c
	nstn=0
	do j=1,npair
c
	if( (atime.ge.lstart(j) .and. atime.le.lstop(j)) .or.
     :    (atime.ge.lstop(j) .and. atime.le.lstart(j)) )nstn=j
	end do
c
	if(spd.gt.0. .and. spd .lt. 40. .and. nstn.ne.0
     :     .and. dir .gt. 0. .and. dir .lt. 360.)then
c
	secdir=90-az(nstn)
	acvel=vtst*cosd(secdir)-utst*sind(secdir)
	alvel=vtst*sind(secdir)+utst*cosd(secdir)
c	type *,az(nstn),utst,vtst,alvel,acvel
	u(nstn)=u(nstn)+utst   !alvel
	v(nstn)=v(nstn)+vtst   !acvel
	n(nstn)=n(nstn)+1
	end if
c
	end do
c
955	sectran=0.
c
	do j=1,npair
	if(n(j).ne.0)then
	  u(j)=u(j)/float(n(j))
	  v(j)=v(j)/float(n(j))
	  spd=sqrt(u(j)*u(j)+v(j)*v(j))
	  dir=90.-atan2d(v(j),u(j))
	  spdus=spd*.514
c	  if(spdus.lt.10)then
		cd=1.14
c	  else
c		cd=.49+.065*spdus
c	  end if
	  tauu=.001*cd*1.4*(u(j)*.514*u(j)*.514)
	  tauv=.001*cd*1.4*(v(j)*.514*v(j)*.514)
	  if(dir.lt.0)dir=dir+360.
	  trek=-tauu/(1025.*f(j))
	  sectran=sectran+trek*wt(j)
c	type '(2i8,2f10.4,4f10.1)',j,n(j),lstart(j),lstop(j),
c     :       u(j),v(j),spd,dir
c	type *,tauu,tauv,trek,sectran
	write(24,880)lstn(j,1),lstn(j,2),
     :  lstart(j),ystart(j),
     :  xstart(j),lstop(j),ystop(j),xstop(j),wt(j),az(j),
     :       u(j),v(j)
880	format(2i5,6f10.4,f10.1,f6.1,2f6.1)
	end if
	end do
c
	stop
	end		
c
	subroutine geodinv (la1,lo1,la2,lo2,dist,azf,azb)
c
c quick geodetic inverse based on NOAA NOS Tech Rep NOS 81 (J Collins)
c lat,lon are in decimal degrees with S,W negative
c dist is returned in meters, azimuths in true degrees 0-360
c
	implicit real*8 (a-m,o-z)       ! only integers are n's
c
c       a=6378206.4   !6378163.  ! alternate values
c       b=6356583.8   !6356177.  ! alternate values
	a=6378135.0   !wgs-72
	b=6356750.5   !wgs-72
c
	if(la1.eq.la2 .and. lo1.eq.lo2)then
		dist=0.
		azb=0.
		azf=0.
		return
	end if
c
	conv = 3.141592654 / 180.
	e0 = a*a - b*b          ! some eccentricities, not all of which
	e1 = e0 / (a*a)         ! are used.
	e2 = e0 / (b*b)
	e3 = e0 / (a*a + b*b)
	e4 = e0 / (a*b)
c
	lat1=la1*conv
	lon1=lo1*conv
	lat2=la2*conv
	lon2=lo2*conv
	dlon=lon2-lon1
c
	tanpsi1 =  b*b * tan(lat1) / (a*a)         ! geocentric lats
	tanpsi2 =  b*b * tan(lat2) / (a*a)
c
	psi1 = atan(tanpsi1)
	psi2 = atan(tanpsi2)
c
	azf = atan2 ( sin(dlon) ,                  !      fwd azimuth
     :        ( tanpsi2 - tanpsi1*cos(dlon) ) * cos(psi1) )
c
	azb = atan2 ( sin(-dlon) ,                 !      back azimuth
     :        ( tanpsi1 - tanpsi2*cos(-dlon) ) * cos(psi2) )
c
	theta1 = atan2(cos(azf),tanpsi1)
	theta2 = atan2(cos(azb),tanpsi2)
c
	beta0 = atan2 ( a * sqrt( tanpsi1*tanpsi1 +
     :          tanpsi2*tanpsi2 - 2.*tanpsi1*tanpsi2*
     :          cos(dlon) ) , b * sin(dlon) )
c
	bbar = b * sqrt ( 1. + e2 * cos(beta0)*cos(beta0) )
	mbar = (a*a - bbar*bbar) / (a*a + bbar*bbar)
c
	rad0 = sqrt ( .5 * (a*a+bbar*bbar) ) * ( 1. - mbar*mbar/16.)
	biga = mbar / 4. + 21.*mbar*mbar*mbar / 128.
	bigb = mbar*mbar / 64.
c
	s1=rad0*(theta1-biga*sin(2.*theta1)+bigb*sin(4.*theta1))
	s2=rad0*(theta2-biga*sin(2.*theta2)+bigb*sin(4.*theta2))
c
	dist = s1 + s2
	azf=azf/conv
	azb=azb/conv
	if(azf.lt.0.)azf=azf+360.
	if(azb.lt.0.)azb=azb+360.

	if(la1.eq.la2)then
		dist=(lo2-lo1)*cosd(la1)*110320.
	end if
c
	return
	end
