	implicit none
c
	integer*4 num_shear
	integer*4 num_avg
	integer*4 num_ens        
	integer*4 nzdn,nzup
c
	parameter (num_shear = 200000, num_avg = 1500, num_ens = 16000)
c
	real*4 dnx,dny,dlsec        
	real*4 sox(num_avg),soy(num_avg),soz(num_avg)
	real*4 dzens(num_ens)        
	real*4 dtens(num_ens)
	real*4 uzens(num_ens)
	real*4 utens(num_ens)
c        
	real*4 std_fac        
	real*4 z1(num_shear)
	real*4 u1(num_shear)
	real*4 v1(num_shear)
	real*4 w1(num_shear)
	integer*4 j        
	integer*4 ie(num_shear)
	integer*4 e1(num_shear)
	real*4 sx(num_avg)
	real*4 sy(num_avg)
	real*4 sz(num_avg)
c        
	real*4 sx2(num_avg)
	real*4 sy2(num_avg)
	real*4 sz2(num_avg)
	real*4 dsec(num_avg)       
	real*4 usec(num_avg)
c
	integer*2 nsx(num_avg)
	integer*2 nsy(num_avg)
	integer*2 nsz(num_avg)
	integer*2 nsxb(num_avg)
	integer*2 nsyb(num_avg)
	integer*2 nszb(num_avg)
c        
	real*4 ushbar(num_avg)
	real*4 vshbar(num_avg)
	real*4 wshbar(num_avg)
c        
	real*4 u(num_avg)
	real*4 v(num_avg) 
	real*4 w(num_avg)
	real*4 vg
	real*4 uav,vav
	real*4 uchk,vchk,wchk
	real*4 uref
	real*4 ubc
	real*4 vref
	real*4 vbc
	real*4 d0,z0,target
	integer*4 nav
c
	integer*2 dalen
	integer*2 proc_yr
	integer*2 proc_mo
	integer*2 proc_day
	integer*2 proc_hr
	integer*2 proc_min
	integer*2 proc_sec
	integer*2 proc_hun
	real*4 bx
	real*4 by
	real*4 cx
	real*4 cy
	integer*4 nshear
	integer*2 nlev
	integer*4 i
	integer*4 izmax        
	integer*2 nlmax
	real*4 s1
	real*4 usum
	real*4 vsum
	real*4 wsum
c
	character*23 day_time
	integer*2 istat
	integer*2 lib$date_time
c
	write(*,*)'Enter LADCP velocity file BIN SIZE', 
     :  ' and STDV EDIT factor '
	read(*,*)vg,std_fac
c
	dalen=80
	open(unit=14,file='process.inf',status='old',form=
     :    'formatted',access='direct',recl=dalen)
c
c	call getdat(proc_yr,proc_mo,proc_day)
c	call gettim(proc_hr,proc_min,proc_sec,proc_hun)
c
	istat=lib$date_time(day_time)
	write(14,fmt=810,rec=14)day_time !proc_day,proc_mo,proc_yr,proc_hr,
c     :   proc_min,proc_sec
c
810     format('Raw File Processed at ',a23 ) !i2.2,'/',i2.2,'/',i4.4,4x,
c     :  i2.2,':',i2.2,':',i2.2)
c	write(14,fmt=810,rec=14)proc_day,proc_mo,proc_yr,proc_hr,
c     :   proc_min,proc_sec
c810     format('LADCP3 run at ',i2.2,'/',i2.2,'/',i4.4,4x,
c     :  i2.2,':',i2.2,':',i2.2)
c
	write(14,rec=15,fmt='(2f8.1)')vg,std_fac
c
	read(14,rec=10,fmt='(i8)')izmax        
	read(14,rec=12,fmt='(2f8.2)')bx,by
	read(14,rec=13,fmt='(2f8.2)')cx,cy
c
	open(unit=76,file='vels.out',status='old',
     :   access='direct',recl=40,form='formatted')
c
	nzdn=0
	do i=1,izmax
	read(76,876,rec=i)d0,z0
876     format(f12.5,f7.1)
	if(z0.gt.0.)then
	nzdn=nzdn+1
	dtens(nzdn)=d0
	dzens(nzdn)=z0
	end if
	end do
c        
	nzup=0
	do i=izmax+1,num_ens
	read(76,876,rec=i,err=344)d0,z0
	if(z0.gt.0.)then
	nzup=nzup+1
	utens(nzup)=d0
	uzens(nzup)=z0
	end if
	end do
c                  
344     open(unit=77,file='shears.out',status='old',
     :   recl=50,form='formatted')
c
	do i=1,num_shear
	read(77,*,err=99)z1(i),u1(i),v1(i),w1(i),ie(i)
	end do
c
99      nshear=i-1
c       
	write(*,*) nshear
c       
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0.)then ! .and. ie(i).lt.izmax)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsx(nlev)=nsx(nlev)+1
	nsy(nlev)=nsy(nlev)+1
	nsz(nlev)=nsz(nlev)+1
	end if
	end do
c        
	do i=1,num_avg       
	nsxb(i)=nsx(i)
	nsyb(i)=nsy(i)
	nszb(i)=nsz(i)
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	if(s1.gt.0.)then
		s1=sqrt(s1/nsx(i))
	else
		s1=0.
	end if
	sox(i)=s1
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	if(s1.gt.0.)then
		s1=sqrt(s1/float(nsy(i)))
	else
		s1=0.
	end if
	soy(i)=s1
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c        
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
c
	uchk=abs(u1(i)-ushbar(nlev))        
	if(uchk.lt.std_fac*sox(nlev))then
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	nsx(nlev)=nsx(nlev)+1
	end if
c        
	vchk=abs(v1(i)-vshbar(nlev))        
	if(vchk.lt.std_fac*soy(nlev))then
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	nsy(nlev)=nsy(nlev)+1
	end if
c
	wchk=abs(w1(i)-wshbar(nlev))        
	if(wchk.lt.std_fac*soz(nlev))then
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsz(nlev)=nsz(nlev)+1
	end if
c
	end if
	end do
c
	do i=1,num_avg
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c        
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
c
	uchk=abs(u1(i)-ushbar(nlev))        
	if(uchk.lt.std_fac*sox(nlev))then
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	nsx(nlev)=nsx(nlev)+1
	end if
c        
	vchk=abs(v1(i)-vshbar(nlev))        
	if(vchk.lt.std_fac*soy(nlev))then
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	nsy(nlev)=nsy(nlev)+1
	end if
c
	wchk=abs(w1(i)-wshbar(nlev))        
	if(wchk.lt.std_fac*soz(nlev))then
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsz(nlev)=nsz(nlev)+1
	end if
c
	end if
	end do
c
	do i=1,num_avg
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	usum=0.
	vsum=0.
	wsum=0.
	do i=1,nlmax
	usum=usum+ushbar(i)*vg
	vsum=vsum+vshbar(i)*vg
	wsum=wsum+wshbar(i)*vg
	u(i)=usum
	v(i)=vsum
	w(i)=wsum
	end do
c
	usum=0.
	wsum=0.
	vsum=0.
	do i=1,nlmax
	wsum=wsum+w(i)
	usum=usum+u(i)
	vsum=vsum+v(i)
	end do
	wsum=wsum/float(nlmax)
	usum=usum/float(nlmax)
	vsum=vsum/float(nlmax)
c
	dsec(1)=dtens(1)
	do i=1,nlmax
	target=i*vg
	do j=1,nzdn-1
	if(dzens(j).le.target .and. dzens(j+1).ge.target)then
	dsec(i+1)=(dtens(j)+dtens(j+1))/2.
	end if
	end do
	end do
	dsec(nlmax+2)=dtens(nzdn)
C
	usec(1)=utens(nzup)
	do i=nlmax,1,-1
	target=i*vg
	do j=1,nzup
	if(uzens(j).ge.target .and. uzens(j+1).le.target)then
	usec(i+1)=(utens(j)+utens(j+1))/2.
	end if
	end do
	end do
	usec(nlmax+2)=utens(1)
c
	dnx=0.
	dny=0.
	do i=2,nlmax
	dlsec=(dsec(i+1)-dsec(i))*86400.
	dnx=dnx+(u(i)-usum)*dlsec
	dny=dny+(v(i)-vsum)*dlsec
	end do
c
	do i=nlmax,2,-1
	dlsec=(usec(i)-usec(i+1))*86400.
	dnx=dnx+(u(i)-usum)*dlsec
	dny=dny+(v(i)-vsum)*dlsec
	end do
c
	ubc=dnx/100./((usec(2)-dsec(2))*86400.)
	vbc=dny/100./((usec(2)-dsec(2))*86400.)
	type *,ubc,vbc,usum,vsum
	if(abs(ubc).gt.10.)ubc=0.
	if(abs(vbc).gt.10.)vbc=0.
	dalen=90
c        
	open(unit=19,file='ladcp.avg',status='new',form=
     :    'formatted',access='direct',recl=dalen)
c
	uav=0.
	vav=0.
	nav=0.
	uref=cx*100. - ubc*100. +bx*100.
	vref=cy*100. - vbc*100. +by*100.
c
	do i=1,nlmax
	u(i)=(u(i)-usum) + uref
	v(i)=(v(i)-vsum) + vref
	w(i)=w(i)-wsum
	uav=uav+u(i)
	vav=vav+v(i)
	nav=nav+1
c
	write(19,rec=i,fmt=801)i*vg-vg/2.,nsx(i),ushbar(i),
     :           sox(i),u(i)/100.,
     :           nsy(i),vshbar(i),soy(i),v(i)/100.,
     :           nsz(i),wshbar(i),soz(i),w(i)/100.
801     format(f7.1,3(i5,3f7.1))
	end do
	close(19)
c
c       do downcast
c
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0. .and. ie(i).lt.izmax)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsx(nlev)=nsx(nlev)+1
	nsy(nlev)=nsy(nlev)+1
	nsz(nlev)=nsz(nlev)+1
	end if
	end do
c        
	do i=1,num_avg       
	nsxb(i)=nsx(i)
	nsyb(i)=nsy(i)
	nszb(i)=nsz(i)
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c        
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0 .and. ie(i).le.izmax)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
c
	uchk=abs(u1(i)-ushbar(nlev))        
	if(uchk.lt.std_fac*sox(nlev))then
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	nsx(nlev)=nsx(nlev)+1
	end if
c        
	vchk=abs(v1(i)-vshbar(nlev))        
	if(vchk.lt.std_fac*soy(nlev))then
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	nsy(nlev)=nsy(nlev)+1
	end if
c
	wchk=abs(w1(i)-wshbar(nlev))        
	if(wchk.lt.std_fac*soz(nlev))then
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsz(nlev)=nsz(nlev)+1
	end if
c
	end if
	end do
c
	do i=1,num_avg
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	usum=0.
	vsum=0.
	wsum=0.
	do i=1,nlmax
	usum=usum+ushbar(i)*vg
	vsum=vsum+vshbar(i)*vg
	wsum=wsum+wshbar(i)*vg
	u(i)=usum
	v(i)=vsum
	w(i)=wsum
	end do
c
	usum=0.
	wsum=0.
	vsum=0.
	do i=1,nlmax
	wsum=wsum+w(i)
	usum=usum+u(i)
	vsum=vsum+v(i)
	end do
	wsum=wsum/float(nlmax)
	usum=usum/float(nlmax)
	vsum=vsum/float(nlmax)
c
	dalen=90
	open(unit=19,file='ladcp.dn',status='new',form=
     :    'formatted',access='direct',recl=dalen)
c
	do i=1,nlmax
	u(i)=(u(i)-usum) + uref
	v(i)=(v(i)-vsum) + vref
	w(i)=w(i)-wsum
	write(19,rec=i,fmt=801)i*vg-vg/2.,nsx(i),ushbar(i),
     :           sox(i),u(i)/100.,
     :           nsy(i),vshbar(i),soy(i),v(i)/100.,
     :           nsz(i),wshbar(i),soz(i),w(i)/100.
	end do
	close(19)
c
c        do upcast
c
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0. .and. ie(i).gt.izmax)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsx(nlev)=nsx(nlev)+1
	nsy(nlev)=nsy(nlev)+1
	nsz(nlev)=nsz(nlev)+1
	end if
	end do
c        
	do i=1,num_avg       
	nsxb(i)=nsx(i)
	nsyb(i)=nsy(i)
	nszb(i)=nsz(i)
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	do i=1,num_avg
	sx(i)=0.
	sz(i)=0.
	sy(i)=0.
	sx2(i)=0.
	sz2(i)=0.
	sy2(i)=0.
	nsx(i)=0
	nsy(i)=0
	nsz(i)=0
	end do
c        
	nlmax=0
	do i=1,nshear
	if(z1(i).gt.0. .and. ie(i).gt.izmax)then
	nlev=int(z1(i)/vg)+1
	nlmax=max(nlmax,nlev)
c
	uchk=abs(u1(i)-ushbar(nlev))        
	if(uchk.lt.std_fac*sox(nlev))then
	sx(nlev)=sx(nlev)+u1(i)
	sx2(nlev)=sx2(nlev)+u1(i)*u1(i)
	nsx(nlev)=nsx(nlev)+1
	end if
c        
	vchk=abs(v1(i)-vshbar(nlev))        
	if(vchk.lt.std_fac*soy(nlev))then
	sy(nlev)=sy(nlev)+v1(i)
	sy2(nlev)=sy2(nlev)+v1(i)*v1(i)
	nsy(nlev)=nsy(nlev)+1
	end if
c
	wchk=abs(w1(i)-wshbar(nlev))        
	if(wchk.lt.std_fac*soz(nlev))then
	sz(nlev)=sz(nlev)+w1(i)
	sz2(nlev)=sz2(nlev)+w1(i)*w1(i)
	nsz(nlev)=nsz(nlev)+1
	end if
c
	end if
	end do
c
	do i=1,num_avg
c
	if(nsx(i).gt.1)then
	s1=sx2(i)-sx(i)*sx(i)/float(nsx(i))
	sox(i)=sqrt(s1/float(nsx(i)))
	ushbar(i)=sx(i)/float(nsx(i))
	end if
c
	if(nsy(i).gt.1)then
	s1=sy2(i)-sy(i)*sy(i)/float(nsy(i))
	soy(i)=sqrt(s1/float(nsy(i)))
	vshbar(i)=sy(i)/float(nsy(i))
	end if
c
	if(nsz(i).gt.1)then
	s1=sz2(i)-sz(i)*sz(i)/float(nsz(i))
	soz(i)=sqrt(s1/float(nsz(i)))
	wshbar(i)=sz(i)/float(nsz(i))
	end if
c
	end do
c        
	usum=0.
	vsum=0.
	wsum=0.
	do i=1,nlmax
	usum=usum+ushbar(i)*vg
	vsum=vsum+vshbar(i)*vg
	wsum=wsum+wshbar(i)*vg
	u(i)=usum
	v(i)=vsum
	w(i)=wsum
	end do
c
	usum=0.
	wsum=0.
	vsum=0.
	do i=1,nlmax
	wsum=wsum+w(i)
	usum=usum+u(i)
	vsum=vsum+v(i)
	end do
	wsum=wsum/float(nlmax)
	usum=usum/float(nlmax)
	vsum=vsum/float(nlmax)
c
	dalen=90
	open(unit=19,file='ladcp.up',status='new',form=
     :    'formatted',access='direct',recl=dalen)
c
	do i=1,nlmax
	u(i)=(u(i)-usum) + uref
	v(i)=(v(i)-vsum) + vref
	w(i)=w(i)-wsum
	write(19,rec=i,fmt=801)i*vg-vg/2.,nsx(i),ushbar(i),
     :           sox(i),u(i)/100.,
     :           nsy(i),vshbar(i),soy(i),v(i)/100.,
     :           nsz(i),wshbar(i),soz(i),w(i)/100.
	end do
	close(19)
c
	stop
	end
