	program matplot
c
	parameter nx=300,ny=300
c
	dimension dummy(nx,ny)
	character color*1,contour*1,another*1,rotate*1,color1*1,nuseg*1
c
	common / matrix / cmat(nx,ny),lx,lz
	common / matlims/ xa,xb,delx,za,zb,delz
	common /undef/ undf
c
	data undf/999.999/
c
        call groute(' ')
c	call gprint(0)
	call gopen
c
	nseg=1
	call gsegcr(nseg)
c
100	continue
c
	call com_init
c
	mtype =1
	call udw_matread
c
	call udw_matchange
c
	ix=lx
	iy=lz
c
	call udw_stats
	call udw_setup
c
	type *,' Do you want: Multiple, Single, or No color contours ',
     :       ' (M/S/N) ?'
	read (*,'(A)')color
	call str$upcase(color,color)
	if(color .eq. 'M' )  then
c
		call udw_classes
		call udw_colors
	        call udw_colorcon (dummy,ix,iy)
c
	else if (color .eq. 'S') then
c
		call udw_classes_one
		call udw_colors_one
	        call udw_colorcon(dummy,ix,iy)
c
        end if
c
	type *,' Do you want contour lines?'
	read (*,'(A)')contour
	call str$upcase(contour,contour)
	if(contour.eq. 'Y')then
             if(color.ne.'M') then
		call udw_classes
                call udw_colors
             end if
                call udw_linecon (dummy,ix,iy)
	end if
c
	call udw_std_axes
c
	type *,' Do you want another plot?'
	read (*,'(A)')another
	call str$upcase(another,another)
	if(another.eq. 'Y' ) then
		type *,' Do you want a new segment? (Y/N)'
		read (*,'(A)')nuseg
		call str$upcase(nuseg,nuseg)
			if(nuseg.eq.'Y') then
				type *,'Plot saved as segment # ',nseg
				call gsegcl(nseg)
				nseg=nseg+1
				call gsegcr(nseg)
			end if
c
		call greset
		goto 100
	end if
c
	call gsegcl(nseg)
	call gclose
c
999     stop
        end
c	
	subroutine udw_stats
	implicit real*8 (a-h,o-z)
	parameter nx=300,ny=300
	character *1 scale,smooth
	real*4 nng,nps,undf,cmat
c
	common / undef  / undf
	common / matrix / cmat(nx,ny),ncx,ncy
c
10	continue
c
	sbarng=0.
	sbarps=0.
	smax=-1.0E6
	smin=1.0E6
	nng=0
	nps=0
	sn2=0.
	sp2=0.
c
	do j=1,ncy
	do i=1,ncx
c
	if(cmat(i,j).ne.undf) then
c
		smin=min(smin,dble(cmat(i,j)))
		smax=max(smax,dble(cmat(i,j)))
		if(cmat(i,j).le.0.)then
			sbarng=sbarng+cmat(i,j)
			sn2=sn2+cmat(i,j)*cmat(i,j)
			nng=nng+1
		end if
c
		if(cmat(i,j).ge.0.)then
			sbarps=sbarps+cmat(i,j)
			sp2=sp2+cmat(i,j)*cmat(i,j)
			nps=nps+1
		end if
c
	end if			! end if ne undf loop
c
	end do
	end do
c
	if(nng.gt.1)then
		sbarng=sbarng/nng
		sdevng=sqrt( ( nng*sn2 - sbarng*sbarng ) / 
     :                 (  nng * (nng-1) ) )
	end if
	if(nps.gt.1)then
		sbarps=sbarps/nps
		sdevps=sqrt( ( nps*sp2 - sbarps*sbarps ) / 
     :                 ( nps * (nps-1) ))
	end if
c
	percneg=(nng/(nng+nps)) * 100.
	percpos=(nps/(nng+nps)) * 100.
c
	vmax=max(abs(smin),smax)
	vmin=min(abs(smin),smax)
c
	if(vmax .le. 1.e5  .and.  vmin .gt. 1e-3) then
	type 801,percneg,smin,sbarng,sdevng,percpos,smax,sbarps,sdevps
	else
	type 800,percneg,smin,sbarng,sdevng,percpos,smax,sbarps,sdevps
	end if
c
800	format(1x,'NEG Values: ',f5.0,' %','  Min ',E10.3,'   Mean ',
     :         E10.3,'  S Dev ',E10.3,/,1x,'POS values: ',f5.0,' %',
     :         '  Max ',E10.3,'   Mean ',E10.3,'  S Dev ',E10.3,//)
c
801	format(1x,'NEG Values: ',f5.0,' %','  Min ',F10.3,'   Mean ',
     :         F10.3,'  S Dev ',F10.3,/,1x,'POS values: ',f5.0,' %',
     :         '  Max ',F10.3,'   Mean ',F10.3,'  S Dev ',F10.3,//)
c
	type *,' Do you want to scale the data?'
	read (*,'(A)')scale
	call str$upcase(scale,scale)
	if(scale.eq. 'Y' )then
		call udw_scale
		goto 10
	end if
c
	type *,' Do you want to smooth the data?'
	read (*,'(A)')smooth
	call str$upcase(smooth,smooth)
	if(smooth.eq. 'Y' )then
		call udw_smooth
		goto 10
	end if
c
	return
	end
c
	subroutine udw_scale
	parameter nx=300,ny=300
c
	common / undef  / undf
	common / matrix / cmat(nx,ny),ncx,ncy
c
	type *,' Enter scale factor'
	accept *,afac
c
	do j=1,ncy
	do i=1,ncx
		if(cmat(i,j).ne.undf)then
			cmat(i,j)=cmat(i,j)*afac
		end if
	end do
	end do
c
	return
	end
c
	subroutine udw_smooth
	parameter nx=300,ny=300
c
	dimension smat(nx,ny),omat(nx,ny)
c
	common / matrix / cmat(nx,ny),ncx,nct
	common / undef  / undf
c
	type *,' Enter smoothing half-widths (points): X , Y '
c
	accept *,nsx,nst
	nft=1
	nlt=nct
	nfx=1
	nlx=ncx
c
	nst1=nft+nst
	nst2=nlt-nst
	nsx1=nfx+nsx
	nsx2=nlx-nsx
c
	do i=1,nx
	do j=1,ny
	omat(i,j)=cmat(i,j)
	end do
	end do
c
        do n=nst1,nst2
c
	do i=nsx1,nsx2
c
	ssum=0.
	ncc=0
	do ix=i-nsx,i+nsx
		if(cmat(ix,n).ne.undf)then
			ssum=ssum+cmat(ix,n)
			ncc=ncc+1
		end if
	end do
c
	do jt=n-nst,n+nst
		if(cmat(i,jt).ne.undf)then
			ssum=ssum+cmat(i,jt)
			ncc=ncc+1
		end if
	end do
c
	if(ncc.ne.0)then
		smat(i,n)=ssum/float(ncc)
	else
		smat(i,n)=undf
	end if
c
	end do
	end do
c
140	continue
c
	do n=1,nct
c
	do i=1,ncx
	cmat(i,n)=smat(i,n)
	end do
c
	do i=nfx+nsx-1,1,-1
	cmat(i,n)=omat(i,n)   !cmat(i+1,n)
c	type *,i,n,cmat(i,n),undf
	end do
c
	do i=nlx-nsx+1,ncx
	cmat(i,n)=omat(i,n)   !cmat(i-1,n)
c	type *,i,n,cmat(i,n),undf
	end do
c
	end do
c
	do i=1,ncx
c
	do j=1,nft+nst-1
	cmat(i,j)=undf
c	type *,i,j,cmat(i,j),undf
	end do
c
	do j=nlt-nst+1,nct
	cmat(i,j)=undf
c	type *,i,j,cmat(i,j),undf
	end do
c
	end do
c
	return
	end
c
	subroutine udw_classes
c
        character ans*1     
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	dimension nzcol(40),ndash(40)
c
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common /colors/in,ip,nzcol
	common /sizes/ asiz,tsiz,csiz,ndec
c
        type *,' Evenly spaced contour classes?'
        accept 5,ans
5       format(a1)
        call str$upcase(ans,ans)
        if(ans.eq.'N') then
c
6          type *,' Enter number of classes'
           accept *,ncl
           if(ncl.gt.30)then
		type *,' No. of classes = ',ncl,'; only 30 allowed'
		goto 6
           end if
           type *,' Enter class value to be zmid'
           accept *,zmid
           do nc=1,ncl
           type *,' Enter class'
           accept *,zcl(nc)
           zcon(nc)=zcl(nc)
           end do
           type *,' Enter number of decimal places in labels'
           accept *,ndec                   
	   ip=0
           in=0
c
	   do i=1,ncl
	   ninc=abs(mod(nint(zcl(i)/10.),2))
           if(ninc.eq.1)then
		ndash(i)=3
	   else
		ndash(i)=3
	   end if                
	   type *,i,zcl(i),ninc,ndash(i)
	   if(zcl(i).gt.zmid)ip=ip+1
	   if(zcl(i).le.zmid)in=in+1
	   cwid(i)=.05				! default contour width
	   conht(i)=2.				! default label size
	   if(zcl(i).eq.zmid)then
c           cwid(i)=.20		                ! zmid contour width
c           conht(i)=2.5	                        ! zmid label size
           ndash(i)=3
	   end if
	   kcol(i)=1				! all contrasting contours
	   end do
c
        else
c   
10	   type *,' Min, max contour value; contour interval '
	   accept *,clow,chigh,cint
c
   	   ncl=(chigh-clow)/cint + 1
	   if(ncl.gt.30)then
		type *,' No. of classes = ',ncl,'; only 30 allowed'
		goto 10
	   end if
c 
	   zmid=clow+int(float(ncl)/2.)*cint
	   if(clow.lt.0. .and. chigh.gt.0. .and. ncl.lt.28)zmid=0.
           do i=1,ncl
	   zcl(i)=clow+float(i-1)*cint   		! color class limits
	   zcon(i)=zcl(i)				! contour class limits
	   ninc=abs(mod(nint(zcl(i)/10.),2))
           if(ninc.eq.1)then
		ndash(i)=3
	   else
		ndash(i)=3
	   end if                
	   type *,i,zcl(i),ninc,ndash(i)
           end do
c
	   ip=0
	   in=0
	   slop1=cint/2.
	   slop2=cint/4.
c
	   do i=1,ncl
	   if(zcl(i).gt.zmid)ip=ip+1
	   if(zcl(i).le.zmid)in=in+1
	   cwid(i)=.05  			! default contour width
	   tstint=abs(zcl(i)-zmid)+slop2
	   if(mod(tstint,2.*cint).lt.slop1)cwid(i)=.05	! alternate width
c	   if(zcl(i).eq.zmid)cwid(i)=.20     ! zero or zmid contour width
	   conht(i)=0.				! default label size
	   if(mod(tstint,2.*cint).lt.slop1)conht(i)=2.0	! alt and zmid
c	   if(zcl(i).eq.zmid)conht(i)=2.5			! label size
	   kcol(i)=1				! all contrasting contours
	   end do
c
	   call num_dec_place (cint,ndec)
c
        end if
	return
	end
c
	subroutine udw_colors
c
	dimension nzcol(40),light(14)
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	integer hue1(15),hue2(15),lg1(15),lg2(15),sat(15)ndash(40)
c
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common /colors/in,ip,nzcol
c
	data hue1/360,240,310,290,360,240,320,270,300,360,240,
     :            330,270,320,220/
	data hue2/160,120,180,130,160,150,180,140,120,80,120,50,
     :            120,70,120/	
	data lg1/30,30,30,30,50,50,50,50,50,70,70,70,70,80,80/
	data lg2/80,80,70,70,60,50,50,50,60,50,50,50,30,40,20/
	data sat/15*100/
c
	data light /92,90,86,84,80,78,74,66,62,56,50,44,38,30/
c
c	Might want to set up different color table here.
c	This assumes 15 shades each of cyan and magenta
c	in colors 20-34 and 35-49 ; dithered (virtual) for 4695 plotting
c
c	call rhtmod('VIR')
	call rcmode ('HLS',100)
c
ccc	CALL GCOLOR (20,HUE1,LG1,SAT,15)
ccc	CALL GCOLOR (35,HUE2,LG2,SAT,15)
c
	do i=1,14
        kol=35-i
	call gcolor(kol,320,light(i),100,1)     !   cyan
	kol=34+i
        call gcolor(kol,80,light(i),100,1)      !   magenta
	end do
c
        iz=max(in,ip)
	do i=1,in
	nzcol(in+1-i)=35-i
	if(iz.le.7)nzcol(in+1-i)=36-2*i
	if(iz.le.5)nzcol(in+1-i)=37-3*i
	end do
c
	do i=1,ip+1
	nzcol(i+in)=34+i
	if(iz.le.7)nzcol(i+in)=33+2*i
	if(iz.le.4)nzcol(i+in)=32+3*i
	end do
c
	call gshade(nzcol,ncl+1)
	call gzcl(zcon,ncl,0)
        return
        end
c
       subroutine udw_matread
	parameter nx=300,ny=300
c
	dimension temp(nx)
	character*40 title,fname
	character*1 dif
        common/undef/undf
c
	common / matrix / cmat(nx,ny),lx,lz
	common / matlims/ xa,xb,delx,za,zb,delz

8	type *,' Enter matfile name'
	accept 900,fname
900	format(a40)
c
	open(unit=8,err=8,file=fname,form='unformatted',status='old',
     :       readonly,defaultfile='[].mat')
	read(8)title
	type *,title
	read(8)xa,xb,delx,za,zb,delz
	read(8)lx,lz
	read(8)((cmat(i,j),i=1,lx),j=1,lz)
c
	close(unit=8)
c
	return
	end
c
       subroutine udw_matchange
c
	parameter nx=300,ny=300
c
	dimension temp(nx),reft(nx)
	character*1 dif,tr
c
        common/undef/undf
	common / matrix / cmat(nx,ny),lx,lz
	common / matlims/ xa,xb,delx,za,zb,delz
c
	type *,'Time reference (0 for NO, or ROW # to subtract)'
	accept *,ireft
c
	if(ireft.ne.0)then
			do i=1,lx
			reft(i)=cmat(i,ireft)
			end do
		do n=1,lz
		do i=1,lx
		if(cmat(i,n).ne.undf .and. reft(i).ne.undf)then
			 cmat(i,n)=cmat(i,n)- reft(i)
		else
   			 cmat(i,n)=undf
		end if
		end do
		end do
	end if
c
	type *,'X, Z, or NO differential?  (X, Z, N)'
	read(*,'(a)')dif
	call str$upcase(dif,dif)
c
	if (dif.eq.'N')goto 222
c
	if (dif.eq.'X')then
		xa=xa+delx/2.		
		xb=xb-delx/2.
		do j=1,lz
		   do i=1,lx-1
                     if(cmat(i+1,j).ne.undf .and. cmat(i,j).ne.undf)then
               	       temp(i)=(cmat(i+1,j)-cmat(i,j))/delx
         	     else
 		       temp(i)=undf
         	     end if
         	   end do
      		   do i=1,lx-1
			cmat(i,j)=temp(i)
		   end do
		end do
		lx=lx-1
	end if
c
	if (dif.eq.'Z')then
		za=za+delz/2.		
		zb=zb-delz/2.
		do i=1,lx
      		   do j=1,lz-1
		     if(cmat(i,j).ne.undf .and. cmat(i,j+1).ne.undf)then
               	       temp(j)=(cmat(i,j)-cmat(i,j+1))/delz
         	     else
 		       temp(j)=undf
         	     end if
         	   end do
		   do j=1,lz-1
			cmat(i,j)=temp(j)
		   end do
		end do
		lz=lz-1
	end if
c
222	continue
223     type *,'Enter xmin,xmax,zmin,zmax area to set to undefined'
        type *,'Enter 999. for all arguments to end entry'
        accept *,x1,x2,z1,z2
        if(x1.eq.999.and.x2.eq.999.and.z1.eq.999.and.z2.eq.999.)
     :go to 225
        nx1=(x1-xa)/delx + 1
        nx2=(x2-xa)/delx + 1
        if(za.gt.zb)then      
        nz1=(z1-za)/(-delz) + 1
        nz2=(z2-za)/(-delz) + 1
        else
        nz1=(z1-za)/delz + 1
        nz2=(z2-za)/delz + 1
        end if
        do isx=nx1,nx2
           do isz=nz1,nz2
           cmat(isx,isz)=undf
           end do
        end do
        go to 223
c
225     return
	end
c
	subroutine udw_setup
c
	character font*4
c
	common / matlims/ xa,xb,delx,za,zb,delz
	common / plotlims/ x0,y0,xmm,zmm
        
	common /sizes/ asiz,tsiz,csiz,ndec
c
c	type *,'Enter text font'
c	read (*,'(a4)')font
	font='HARD'
	call gcharf(font)
c
	type *,'Enter X, Y origins in mm'
	accept *,x0,y0
c
	if(xa.lt.0. .and. xb.lt.0.)then
		xa=-xa
		xb=-xb
		delx=-abs(delx)
	end if
c
	if(xa.gt.0. .and. xb.lt.0.)then
		xa=xa-360.
		xb=-xb
		delx=-abs(delx)
	end if
c
	type *,' X limits are ',xa,xb
	type *,'Enter X plot size in mm'
	accept *,xmm
c
	type *,' Z limits are ',za,zb
	type *,'Enter Z plot size in mm'
	accept *,zmm
c
	xl=xmm/1000.
	zl=zmm/1000.
c
	asiz=2.8 + zmm/100.
	if(asiz.gt.4.)asiz=4.
	tsiz=3.0 + zmm/100.
	csiz=1.8 + zmm/100.
	if(csiz.gt.3.)csiz=3.
c
	call glimit(xa,xb,za,zb,0.,0.)
	call gvport(x0,y0,xmm,zmm)
	call gwbox(xl,zl,0.)
c
	return
	end
c
	subroutine udw_colorcon (smat,n1,n2)
	parameter nx=300,ny=300
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	dimension smat(n1,n2),nzcol(40),ndash(40)
	character gco*1
c
	common / matrix / cmat(nx,ny),ncx,nct
	common / plotlims/ x0,y0,xmm,zmm
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common /sizes/ asiz,tsiz,csiz,ndec
	common /colors/in,ip,nzcol
	common /undef/ undf
c
	do i=1,n1
	do j=1,n2
	smat(i,j)=cmat(i,j)
	end do
	end do
c
        call geowid(0.5)
        call geocol(1)
	call gconla(cwid,kcol,ncl)
	call gconda(ndash,ncl)
	call gundef(undf,9999)
	call gconab(9999,0)
	call gcnr2s(smat,n1,n2)
c
c	type *,' Do you want to plot a color legend?'
c	read (*,'(A)')gco
c	call str$upcase(gco,gco)
c	if(gco .eq. 'Y' )then
c		call gscsco('Below$Above$$',4.,ndec,0,1)
c		call gcoscl(x0+xmm+25.,y0)
c	end if
c
	return	
	end
c
	subroutine udw_linecon (smat,n1,n2)
	parameter nx=300,ny=300,nwork=nx*ny
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	dimension smat(n1,n2),work(nwork),cht(40),ndash(40)
	character*1 labyn
c
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common / matrix / cmat(nx,ny),ncx,nct
	common /sizes/ asiz,tsiz,csiz,ndec
	common /undef/ undf
c
	epsilon=.001
c
	do i=1,n1
	do j=1,n2
              if(cmat(i,j).ne.undf)then
                   smat(i,j)=cmat(i,j)+epsilon
              else
                   smat(i,j)=cmat(i,j)
              end if
	end do
       	end do
c
	call gzcl(zcon,ncl,0)
c
	call gconla(cwid,kcol,ncl)   		! for variable size &
c	call gconah(conht,ncl)                  ! width contour labels
c
	call geowid(0.5)
	call geocol(1)
	gmm=-100.
	moveover=3
	type *,' CSIZ ',csiz
	type *,'Contour labels? (Y/N)'
	read(*,'(a)')labyn
	call str$upcase(labyn,labyn)
	if(labyn.eq.'Y')call gcona(csiz,ndec,gmm,moveover)
c	call gconaa(-60,60)
c
	call gundef(undf,9999)
	call gconda(ndash,ncl)
	call gconab(9999,0)
	call gcnr2v(smat,n1,n2)
c
	return	
	end
c
	subroutine udw_std_axes
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40),ndash(40)
	character atit1*80,atit2*80,atit3*80,ATIT4*80
c
	common / matlims/ xa,xb,delx,za,zb,delz
	common /plotlims/ x0,y0,xmm,zmm
	common /sizes/asiz,tsiz,csiz,ndec
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
c
	type *,' X AXIS:  min =',xa,'  max =',xb,'  delta =',delx
	type *,' Enter min,max,delta1,delta2'
	accept *,xaxmin,xaxmax,xaxdlt1,xaxdlt2
	xaxdif=xaxmax-xaxmin
	tickx=xaxdif/xaxdlt2
        itickx=int(xaxdlt1/xaxdlt2)
	mtx=int(tickx)
	call num_dec_place(xaxmin,nxd1)
	call num_dec_place(xaxdlt1,nxd2)
	nxdec=max(nxd1,nxd2)
c
	type *,' Y AXIS:  min =',za,'  max =',zb,'  delta =',delz
	type *,' Enter min,max,delta1,delta2'
	accept *,zaxmin,zaxmax,zaxdlt1,zaxdlt2
	zaxdif=zaxmax-zaxmin
	tickz=zaxdif/zaxdlt2
        itickz=int(zaxdlt1/zaxdlt2)
	mtz=int(tickz)
	call num_dec_place(zaxmin,nzd1)
	call num_dec_place(zaxdlt1,nzd2)
	nzdec=max(nzd1,nzd2)
c
	call gwicol(.4,1)
	call gaxori(xaxmin,zaxmin)
	call gaxlab(4.,asiz,nxdec,0)
        call gtickm(itickx)
        call gaxis(1,xaxmin,xaxdlt1,xaxmax,'Degrees Latitude $')
	call gaxori(xaxmin,zaxmin)
        call gaxlab(4.,asiz,nzdec,0)
        call gtickm(itickz)
	call gaxis(2,zaxmin,zaxdlt1,zaxmax,'Depth in Meters $')
c
	call gaxlab(4.,asiz,0,0)
	call gaxori(xaxmin,zaxmax)
	call gaxend(2)
c	call gtickm(mtx)
	call gaxcol(1,0,0)
	call gaxis(-1,xaxmin,xaxdif,xaxmax,'$')
	call gaxlab(4.,asiz,0,0)
	call gaxori(xaxmax,zaxmin)
	call gaxend(2)
c	call gtickm(mtz)
	call gaxcol(1,0,0)
	call gaxis(-2,zaxmin,zaxdif,zaxmax,'$')
c
	type *,' Enter 80 character title line 1'
	accept 808,nt1,atit1
	type *,' Enter 80 character title line 2'
	accept 808,nt2,atit2
	type *,' Enter 80 character title line 3'
	accept 808,nt3,atit3
	type *,' Enter 80 character title line 4'
	accept 808,nt4,atit4
808	format(q,a80)
c
	atit1(nt1+1:nt1+1)='$'
	atit2(nt2+1:nt2+1)='$'
	atit3(nt3+1:nt3+1)='$'
	atit4(nt4+1:nt4+1)='$'
c
	call gcharj(0)
c
	zaxl=y0 + zmm + ( zmm * (zaxmax - zb) ) / (zb - za) 
	yt1=zaxl + 5.5*tsiz
	yt2=zaxl + 4.*tsiz
	yt3=zaxl + 2.5*tsiz
	yt4=zaxl + 1.*tsiz
	tsiz1=tsiz * .9
	tsiz2=tsiz * .8
	tsiz3=tsiz * .7
	tsiz4=tsiz !* .7
c
	call gchar(atit1,x0+2.,yt1,tsiz)
	if (nt2.ne.0) call gchar(atit2,x0+2.,yt2,tsiz2)
	if (nt3.ne.0) call gchar(atit3,x0+2.,yt3,tsiz3)
	if (nt4.ne.0) call gchar(atit4,x0+2.,yt4,tsiz4)
c
	return
	end
c
        SUBROUTINE ENTERP(X,XT,YT,NX,NPX,Y,NERR)
        DIMENSION XT(1),YT(1)
        NERR=0
        INTER=1
        NP=NPX
        IF(NX.LT.NP) NP=NX
        IH=NP/2
        I=1
        IF(XT(I)-X)30,20,10
10        IH=0
12        NERR=1
        GO TO 70
13        NERR=2
        GO TO 70
20        INTER=2
22        Y=YT(I)
        GO TO 999
30        I=NX
        IF(XT(I)-X)13,20,40
40     N1=1
        N2=NX
45      MP=(N1+N2)/2
50      IF(XT(MP)-X)52,54,56
52      N1=MP
        GO TO 60
54      I=MP
        GO TO 20
56      N2=MP
60      IF(N2-N1.NE.1) GO TO 45
        I=MAX0(N2,IH+1)
70        K=I-IH
        N=K+NP-1
        Y=0.
        IF(N-NX)90,90,80
80        N=NX
        K=NX-NP+1
90        DO 120 J=K,N
        P=1.
        DO 110 I=K,N
        IF(I-J)100,110,100
100        P=P*(X-XT(I))/(XT(J)-XT(I))
110        CONTINUE
120        Y=Y+YT(J)*P
999      RETURN
        END
c
	subroutine num_dec_place (test0,ndec)
c
	test=abs(test0)
	ndec=0
c
	do i=1,10
c
	ntest=int(test)
	tmod=test-float(ntest)
	if(tmod.lt..001)then
		ndec=0
		return
	end if
	tm10=tmod*10
	itm=nint(tm10)
	ttt=abs(tm10-float(itm))
	if(ttt .lt. .001)	then
		ndec=i
		return
	end if
	test=tmod*10.
c
	end do
c
	return
	end
	
	subroutine com_init
	parameter nx=300,ny=300
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	dimension nzcol(40),ndash(40)
c
	common / matrix / cmat(nx,ny),lx,lz
	common / matlims / xa,xb,delx,za,zb,delz
	common / classlims / ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common / colors / in,ip,nzcol
	common / sizes / asiz,tsiz,csiz,ndec
	common / plotlims/ x0,y0,xmm,zmm
c
	do i=1,nx
	do j=1,ny
	cmat(i,j)=0.
	end do
	end do
c
	do i=1,40
	zcl(i)=0.
	zcon(i)=0.
	cwid(i)=0.
	conht(i)=0.		
	kcol(i)=0
	nzcol(i)=0
	end do
c
	lx=0
	ly=0
	xa=0.
	xb=0.
	delx=0.
	za=0.
	zb=0.
	delz=0.
	in=0
	ip=0
c
	asiz=0.
	tsiz=0.
	csiz=0.
	ndec=0
	zmid=0.
	x0=0.
	y0=0.
	xmm=0.
	zmm=0.
c
	return
	end
c
	subroutine udw_classes_one
c
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
	dimension nzcol(40),ndash(40)
c
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common /colors/in,ip,nzcol
	common /sizes/ asiz,tsiz,csiz,ndec
c
	ncl=1
	type *,'Enter zmid contour value for shading'
	accept *,zmid
        zcl(1)=zmid   		! shading class limits
c
	call num_dec_place(zmid,ndec)
c
	return
	end

	subroutine udw_colors_one
c
	dimension nzcol(40),light(14),ndash(40)
	dimension zcl(40),zcon(40),cwid(40),conht(40),kcol(40)
c
	common /classlims/ncl,zcl,zcon,cwid,conht,kcol,zmid,ndash
	common /colors/in,ip,nzcol
c
	data light /92,90,86,84,80,78,74,66,62,56,50,44,38,30/
c
c	Might want to set up different color table here.
c	This assumes 14 shades each of cyan and magenta
c	in colors 21-34 and 35-48 ; dithered (virtual) for 4695 plotting
c
	call rhtmod('VIR')
	call rcmode ('HLS',100)
c
	do i=1,14
        kol=35-i
	call gcolor(kol,320,light(i),100,1)     !   cyan
	kol=34+i
        call gcolor(kol,80,light(i),100,1)      !   magenta
	end do
c
	nzcol(1)=9
	nzcol(2)=0
c
	call gshade(nzcol,2)
        call gzcl(zmid,1,0)
c
	return
        end

